#include <DualVNH5019MotorShield.h>

#include "DualVNH5019MotorShield.h"

DualVNH5019MotorShield md;
// encoder pin initalization
int EncoderM1_PinA = 3;
int EncoderM1_PinB = 5;

// initalize the position and time related variables
volatile long encoder0Pos=0;
long newposition;
long oldposition = 0;
unsigned long newtime;
unsigned long oldtime = 0;
long vel;
double speed_act = 0;     // speed (actual value)

// Variable for angular velocity measurement
float ang_velocity_right = 0;
float ang_velocity_right_deg = 0;

 // conversion factors
const float rpm_to_radians = 0.10471975512;
const float rad_to_deg = 57.29578;

//int difference;
////int CPR = 5; // 1 rotation 5 counts as its 20 cpr quadrature encoder //4*5  ppr=cpr/4
int CPR = 20;  //20*156 = 3120 CPR, 20cpr quadrature encoder 156:1 6V brushed dc motor

void stopIfFault()
{
  if (md.getM1Fault())
  {
    Serial.println("M1 fault");
    while(1);
  }
  
}

void doEncoder0B(){ // interrupt 1 function
if (digitalRead(EncoderM1_PinB) == HIGH) { // look for a low-to-high on channel B
if (digitalRead(EncoderM1_PinA) == HIGH) { // check channel A to see which way encoder is turning
encoder0Pos = encoder0Pos + 1;
}
else {
encoder0Pos = encoder0Pos - 1;
}
}
else { // must be a high-to-low edge on on channel B
if (digitalRead(EncoderM1_PinA) == LOW) { // check channel B to see which way encoder is turning
encoder0Pos = encoder0Pos + 1;
}
else {
encoder0Pos = encoder0Pos - 1;
}
}
}

void loop()
{

 md.setM1Speed(-400);
 delay(50);
 newposition = encoder0Pos;
 newtime = millis();
// vel = (newposition-oldposition) * 1000 /(newtime-oldtime);
speed_act = (newposition-oldposition)*60L* 1000 /(156.25*(newtime-oldtime)*CPR);
ang_velocity_right = speed_act * rpm_to_radians;   
ang_velocity_right_deg = ang_velocity_right * rad_to_deg;
// print the values in the serial monitor
 Serial.print(" Pulses: ");
 Serial.println(encoder0Pos);
 Serial.print ("RPM = ");
 Serial.println (speed_act);
 Serial.print(" Angular Velocity: ");
    Serial.print(ang_velocity_right);
    Serial.print(" rad per second");
    Serial.print("\t");
    Serial.print(ang_velocity_right_deg);
    Serial.println(" deg per second");
 oldposition = newposition;
 oldtime = newtime;
 delay(250);
 //md.setM1Speed(0);
}


void setup()
{
  Serial.begin(9600);
  delay(2000);
  Serial.println("Dual VNH5019 Motor Shield");
  
  md.init();
  pinMode(EncoderM1_PinA, INPUT);
  digitalWrite(EncoderM1_PinA, HIGH);       // turn on pullup resistor
  pinMode(EncoderM1_PinB, INPUT);
  digitalWrite(EncoderM1_PinB, HIGH);       // turn on pullup resistor
  //attachInterrupt(0, doEncoder, RISING);  // encoDER ON PIN 2
  //attachInterrupt(digitalPinToInterrupt(EncoderM1_PinA), doEncoder, RISING);  // encoDER ON PIN 2
  attachInterrupt(1, doEncoder0B, CHANGE);
  Serial.begin (9600);
  Serial.println("start"); 
  
}
